# 躯体図柱断面作成
# shinya_mugino  1999.02 - 202307
BEGIN{
	# 引数解析
  for(i=2;i<=ARGC-1;i++){	
	#前出オプションが空だとオプション番号は繰り上がる
	#Bが空だと次のDは空でないなら　ARGV[2]と繰り上がるため繰返し解析する
		if(ARGV[i]~/B/){b =substr(ARGV[i],2,length(ARGV[i])-1)}
		if(ARGV[i]~/D/){d =substr(ARGV[i],2,length(ARGV[i])-1)}
		if(ARGV[i]~/C/){cnm =substr(ARGV[i],2,length(ARGV[i])-1)}
		if(ARGV[i]~/IFT/){ift =substr(ARGV[i],4,length(ARGV[i])-3)}
		if(ARGV[i]~/N/){n =substr(ARGV[i],2,length(ARGV[i])-1)}
	}	#for
 	
 	print "変数確認jwc_temp.txtで-----------"
	print "ARGV[1]=" ARGV[1]
	print "ARGV[2]=" ARGV[2]
	print "ARGV[3]=" ARGV[3]
	print "ARGV[4]=" ARGV[4]
	print "ARGV[5]=" ARGV[5]
	print "ARGV[6]=" ARGV[6]
 	print "-------------------"
	
	ARGV[2] ="" ;ARGV[3] ="" ;ARGV[4] ="" ;ARGV[5] ="" ;ARGV[6] =""	#解放
 	# 変数確定　ファイルに格納・引出し(前回ﾃﾞｰﾀ再利用)
 	if(b==0){
 		getline <"C:\\JWW\\jw_tool\\Rc_kutai\\Rc_gaihen\\S_B.TXT"
 		b =$0
 	}else{
 		print b >"S_B.TXT"	#フルパスでなくて可(batと同じフォルダー)
 	}#if(b==0)
 	if(d==0){
 		getline <"C:\\JWW\\jw_tool\\Rc_kutai\\Rc_gaihen\\S_D.TXT"
 		d =$0
 	}else{
 		print d >"S_D.TXT"
 	}#if(d==0)
 	if(cnm==0){
 		getline <"C:\\JWW\\jw_tool\\Rc_kutai\\Rc_gaihen\\S_CNM.TXT"
 		cnm =$0
 	}else{
 		print cnm >"S_CNM.TXT"
 	}
 	if(ift==0){
 		getline <"C:\\JWW\\jw_tool\\Rc_kutai\\Rc_gaihen\\rcc_ift.txt"
 		ift =$0
 	}else{
 		print ift >"rcc_ift.txt"
 	}
 	if(n==0){
 		getline <"C:\\JWW\\jw_tool\\Rc_kutai\\Rc_gaihen\\rcc_n.txt"
 		n =$0
 	}else{
 		print n>"rcc_n.txt"
 	}
	# 壁厚150芯振分として基準点より柱芯ｵﾌｾｯﾄ
	of_B =b/2-75; of_D =d/2-75
	# 壁と同じﾚｲﾔで作図し手動で包絡処理後柱(色・ﾚｲﾔ分け)にする?
	#	print "lc7";	print "lt1";	print "ly7";
	l_clm()	#ｺﾗﾑ設定
}#begin

/^hp1/{
	xs =$2
	ys =$3
}#^hp1
END{
	if(xs>0){xs =of_B}	#柱芯設定
	if(xs<0){xs =-of_B}
	if(ys>0){ys =of_D}
	if(ys<0){ys =-of_D}
	
	sikaku(xs,ys,b,d)	#躯体線
	print "cn7" 
	moji(xs-b/2+75,ys-d/2+10,xs-b/2+1000000,ys-d/2+10,cnm)	#柱記号
	
	# ﾀﾞﾐｰ寸法線値_lc9 lt1 ly9
	l_snp()
	print "z3" 
	print "msg" 
	yoko(xs-b/2,xs+b/2,ys-d/2)	#下 寸法線
	print "cn10" 
	print "cs" ,xs ,ys-d/2 ,xs+1000000 ,ys-d/2 ,"\""b		#下寸法値
	print "ch" ,xs-12 ,ys-d/2 ,xs-12+1000000 ,ys-d/2 ,"\"""B"	#幅記号 -12は1文字分逃し位置
	print "z3" 
	print "msg" 
	tate(xs+b/2,ys-d/2,ys+d/2)	#右
	print "cs" ,xs+b/2 ,ys ,xs+b/2 ,ys+1000000 ,"\""d		#右
	print "ch" ,xs+b/2 ,ys-12 ,xs+b/2 ,ys-12+1000000 ,"\"""D"	
	# 仕上線
	l_fns()	#仕上設定
	#上線1　右線2　下線3　左線4で描画
	if(n==12 || n==21){	#上・右線
		yoko(xs-b/2,xs+b/2+ift,ys+d/2+ift)	#上
		tate(xs+b/2+ift,ys-d/2-ift,ys+d/2+ift)	#右
	}
	if(n==123 || n==321){	#上・右・下線
		yoko(xs-b/2,xs+b/2+ift,ys+d/2+ift)	#上
		tate(xs+b/2+ift,ys-d/2-ift,ys+d/2+ift)	#右
		yoko(xs-b/2,xs+b/2+ift,ys-d/2-ift)	#下
	}
	if(n==23 || n==32){	#右・下線
		tate(xs+b/2+ift,ys-d/2-ift,ys+d/2+ift)	#右
		yoko(xs-b/2,xs+b/2+ift,ys-d/2-ift)	#下
	}
	if(n==234 || n==432){	#右・下・左線
		tate(xs+b/2+ift,ys-d/2-ift,ys+d/2)	#右
		yoko(xs-b/2-ift,xs+b/2+ift,ys-d/2-ift)	#下
		tate(xs-b/2-ift,ys-d/2-ift,ys+d/2)	#左
	}
	if(n==34 || n==43){	#下・左線
		yoko(xs-b/2-ift,xs+b/2,ys-d/2-ift)	#下
		tate(xs-b/2-ift,ys-d/2-ift,ys+d/2)	#左
	}
	if(n==341 || n==143){	#下・左・上線
		yoko(xs-b/2-ift,xs+b/2,ys-d/2-ift)	#下
		tate(xs-b/2-ift,ys-d/2-ift,ys+d/2+ift)	#左
		yoko(xs-b/2-ift,xs+b/2,ys+d/2+ift)	#上
	}
	if(n==41 || n==14){	#左・上線
		yoko(xs-b/2-ift,xs+b/2+ift,ys+d/2+ift)	#上
		tate(xs-b/2-ift,ys-d/2,ys+d/2+ift)	#左
	}
	if(n==412 || n==214){	#左・上・右線
		tate(xs-b/2-ift,ys-d/2-ift,ys+d/2+ift)	#左
		yoko(xs-b/2-ift,xs+b/2+ift,ys+d/2+ift)	#上
		tate(xs+b/2+ift,ys-d/2,ys+d/2+ift)	#右
	}
	if(n==1234 || n==4321){	#四方仕上線
		yoko(xs-b/2-ift,xs+b/2+ift,ys+d/2+ift)	#上
		tate(xs+b/2+ift,ys-d/2-ift,ys+d/2+ift)	#右
		yoko(xs-b/2-ift,xs+b/2+ift,ys-d/2-ift)	#下
		tate(xs-b/2-ift,ys-d/2-ift,ys+d/2+ift)	#左
	}
	
	print "ift="ift
	print "n="n
	
	
}#end

#躯体線 線色・線種・レイヤ設定
function l_clm(){
	print "lc7";	print "lt1";	print "ly7";
}
#仕上線 線色・線種・レイヤ設定
function l_fns(){
	print "lc6";	print "lt1";	print "ly6";
}
#寸法線 線色・線種・レイヤ設定
function l_snp(){
	print "ly9" ;print "lc9" ;print "lt1" #	;print "$<MS ゴシック>"
}

function sikaku(x1,y1,b1,h1){
	tate(x1-b1/2,y1-h1/2,y1+h1/2)	#左
	tate(x1+b1/2,y1-h1/2,y1+h1/2)	#右
	yoko(x1-b1/2,x1+b1/2,y1-h1/2)	#下
	yoko(x1-b1/2,x1+b1/2,y1+h1/2)	#上
}
function tate(x1,y1,y2){
	printf "%e %e %e %e\n",x1,y1,x1,y2
}
function yoko(x1,x2,y1){
	printf "%e %e %e %e\n",x1,y1,x2,y1
}
function moji(x0,y0,x1,y1,s) {
	printf("ch %e %e %e %e \"%s\n", x0, y0, x1, y1,s);
}

